	function cATTDbg::InitParseTable()
//	----------------------------------
{
	local t = {

_AT	  = {_NULL_	= ["_AT"   ,{_P1_	= [_EOL,1]}]
	    },
CANCEL	  = {ALL	= ["CANALL",null],
	     BREAK	= ["CANBRK",{ALL	= null,
				     CALL	= null,
				     LINE	= null,
				     RETURN	= null,
				     _P1_	= [_ADDR,_ZERO_PLUS],
				     _CONFLICT_ = [["_P1_","ALL","CALL"],
						   ["_P1_","ALL","LINE"],
						   ["_P1_","ALL","RETURN"]
						  ]
				    }],
	     MODULE	= ["CANMOD",null],
	     TRACE	= ["CANTRA",{ALL	= null,
				     CALL	= null,
				     LINE	= null,
				     _P1_	= [_ADDR,_ZERO_PLUS]
				    }],
	     WATCH	= ["CANWAT",{ALL	= null,
				     _P1_	= [_WATCH,_ZERO_PLUS]
				    }]
	    },
DEFINE	  = {_NULL_	= ["DEFINE",{_P1_	= [_SYMBOL,1],
				     _P2_	= ["=",1],
				     _P3_	= [_EOL,1]
				    }]
	    },
DELETE	  = {_NULL_	= ["DELETE",{ALL	= null,
				     _P1_	= [_SYMBOL,_ZERO_PLUS]
				    }]
	    },
DEPOSIT	  = {_NULL_	= ["DEPOS" ,{_P1_	= [_VAR,1],
				     _P2_	= ["=",1],
				     _P3_	= [_EOL,1]
				    }]
	    },
EVALUATE  = {_NULL_	= ["EVAL"  ,{FILTER	= null,
				     HEX	= null,
				     LIST	= null,
				     SORT	= null,
				     TILE	= null,
				     _P1_	= [_EOL,1]
				    }]
	    },
EXAMINE	  = {_NULL_	= ["EXAMIN",{FILTER	= null,
				     HEX	= null,
				     LOCALS	= null,
				     SORT	= null,
				     TILE	= null,
				     _P1_	= [_VAR,_ZERO_PLUS]
				    }]
	    },
GO	  = {_NULL_	= ["GO"    ,{PAUSED	= null,
				     RUN	= null,
				     _CONFLICT_	= [["PAUSED","RUN"]]
				    }]
	    },
SET	  = {AUTOPAUSE	= ["SETAUP",null],
	     BREAK	= ["SETBRK",{AFTER	= [_INT,1,1,10000000],
				     CALL	= null,
				     INTO	= null,
				     LINE	= null,
				     NOSILENT	= [_ISNO],
				     NOSOURCE	= [_ISNO],
				     OVER	= null,
				     RETURN	= null,
				     SILENT	= [_HASNO],
				     SOURCE	= [_HASNO],
				     TEMPORARY	= null,
				     _DO_	= null,
				     _WHEN_	= null,
				     _P1_	= [_ADDR,_ZERO_PLUS]
				     _CONFLICT_ = [["_P1_","INTO","OVER"],
						   ["_P1_","CALL"],
						   ["_P1_","LINE"],
						   ["_P1_","RETURN"]
						  ]
				    }],
	     FILTER	= ["SETFIL",{_P1_	= [_SYMBOLW,_ZERO_PLUS]}],
	     FUNCTIONS	= ["SETFUN",null],
	     LINES	= ["SETLIN",{_P1_	= [_INT,1,1,10000000]}],
	     LOG	= ["SETLOG",{_P1_	= [_EOL,_ZERO_OR_ONE]}],
	     NOAUTOPAUSE= ["SETNAP",null],
	     NOLOG	= ["SETNLG",null],
	     NOFUNCTIONS= ["SETNFN",null],
	     MODULE	= ["SETMOD",{_P1_	= [_EOL,1]}],
	     PROMPT	= ["SETPRM",{_P1_	= [_STR,1]}],
	     SCOPE	= ["SETSCP",{_P1_	= [_SCOPE,1]}],
	     SOURCE	= ["SETSRC",{_P1_	= [_EOL,1]}],
	     STEP	= ["SETSTP",{CALL	= null,
				     INTO	= null,
				     LINE	= null,
				     NOSILENT	= [_ISNO],
				     NOSOURCE	= [_ISNO],
				     OVER	= null,
				     RETURN	= null,
				     SILENT	= [_HASNO],
				     SOURCE	= [_HASNO],
				     _CONFLICT_	= [["INTO","OVER"],
						   ["CALL","LINE"],
						   ["RETURN","LINE"]
						  ]
				    }],
	     TABSTOP	= ["SETTAB",{_P1_	= [_INT,1,2,8]}],
	     TRACE	= ["SETTRC",{AFTER	= [_INT,1,1,10000000],
				     CALL	= null,
				     INTO	= null,
				     LINE	= null,
				     NOSILENT	= [_ISNO],
				     NOSOURCE	= [_ISNO],
				     OVER	= null,
				     RETURN	= null,
				     SILENT	= [_HASNO],
				     SOURCE	= [_HASNO],
				     TEMPORARY	= null,
				     _P1_	= [_ADDR,_ZERO_PLUS]
				    }],
	     WATCH	= ["SETWAT",{AFTER	= [_INT,1,1,10000000],
				     INTO	= null,
				     NOSILENT	= [_ISNO],
				     NOSOURCE	= [_ISNO],
				     OVER	= null,
				     SILENT	= [_HASNO],
				     SOURCE	= [_HASNO],
				     TEMPORARY	= null,
				     _DO_	= null,
				     _WHEN_	= null,
				     _P1_	= [_WATCH,_ZERO_PLUS]
				    }],
	    },
SHOW	  = {AUTOPAUSE	= ["SHOAUP",null],
	     BREAK	= ["SHOBRK",null],
	     CALLS	= ["SHOCAL",{_P1_	= [_INT,_ZERO_OR_ONE,1,100]}],
	     FILTER	= ["SHOFIL",null],
	     FUNCTIONS	= ["SHOFUN",null],
	     LINES	= ["SHOLIN",null],
	     LOG	= ["SHOLOG",null],
	     MODULE	= ["SHOMOD",null],
	     SCOPE	= ["SHOSCP",null],
	     SOURCE	= ["SHOSRC",null],
	     STEP	= ["SHOSTP",null],
	     SYMBOL	= ["SHOSYM",{_P1_	= [_SYMBOLW,_ZERO_PLUS]}],
	     TABSTOP	= ["SHOTAB",null],
	     TRACE	= ["SHOTRC",null],
	     WATCH	= ["SHOWAT",null]
	    },
STEP	  = {_NULL_	= ["STEP"  ,{CALL	= null,
				     INTO	= null,
				     LINE	= null,
				     NOSILENT	= [_ISNO],
				     NOSOURCE	= [_ISNO],
				     OVER	= null,
				     RETURN	= null,
				     SILENT	= [_HASNO],
				     SOURCE	= [_HASNO],
				     _P1_	= [_INT,_ZERO_OR_ONE,1,1000000],
				     _CONFLICT_ = [["INTO","OVER"],
						   ["CALL","LINE"],
						   ["RETURN","LINE"]
						  ]
				    }]
	    },
TYPE	  = {_NULL_	= ["TYPE"  ,{LINES	= [_INT,1,1,10000000],
				     _P1_	= [_LINERANGE,_ZERO_OR_ONE]
				    }]
	    }
	};

	c_parser.Initialize(t);
}
	function cATTDbg::ParseInput()
//	------------------------------
{
	if(c_input[0] == WKC_ESC) {
	  if(c_running) {
	    CancelStepBreak();
	    Break(ATTDBG_BREAK_ESC);
	  }
	  else
	    AIController.Pause();

	  return;
	}

	ParseCommandLine(c_input);
}
	function cATTDbg::ParseCommandLine(cmdline)
//	-------------------------------------------
//	Break command line into commands on ';' and execute each command
{
	local	ret = SplitCommandLine(cmdline);

	if(::type(ret) == "integer") {
	  if(c_cmdlvl) OutputW(cmdline);

	  OutputW(c_parser.GetErrorStr(ret));
	}
	else {
	  foreach (i,v in ret)
	    ParseCommand(strip(v));
	}
}
	function cATTDbg::ParseCommand(cmd)
//	-----------------------------------
{
	if(!cmd.len()) return ATT_PE_SUCCESS;

	c_exect = c_parser.ParseCommand(cmd);

	if("newcmd" in c_exect) {
	  local	newcmd = c_exect.newcmd;
	  ParseCommandLine(newcmd);
	  return;
	}
/*
	Ex("c_exect");

	if("qualt" in c_exect) {
	  Ex("c_exect.qualt");

	  foreach (name,val in c_exect.qualt)
	    if(val != null) Ex("c_exect.qualt."+name);
	}

	Output("");
*/
	if(c_exect.errcode != ATT_PE_SUCCESS) {
	  if(c_cmdlvl) OutputW(c_exect.cmd);

	  local str = c_parser.GetErrorStr(c_exect.errcode);

	  if(c_exect.errpos < c_exect.cmd.len())
	    OutputW(str + ": " + c_exect.cmd.slice(c_exect.errpos));
	  else
	    OutputW(str);

	  return c_exect.errcode;
	}

	return ExecuteCmd();
}
	function cATTDbg::GetValue(obj,dspflg=0)
//	----------------------------------------
//	Return object value as string or object type if not atomic
//	dspflg	ATT_DF_ display flag bits
{
	local	otype;

	switch(otype = ::type(obj)) {
	case "table":
	case "array":
	case "class":
	case "instance":
	case "null":
	case "function":
	case "generator":
	  return otype;

	case "integer":
	  if(dspflg & ATT_DF_HEX) return ::format("0x%8.8X",obj);

	  if(dspflg & ATT_DF_TILE)
	    return ::format("%d,%d,%d (0x%8.8X)",
			AIMap.GetTileX(obj),AIMap.GetTileY(obj),
			AITile.GetMaxHeight(obj),obj);
//	  Fall thru

	case "float":
	  return obj.tostring();

	case "string":
	  return "\"" + obj + "\"";

	case "bool":
	  return obj.tostring();
	}

	OutputE("GetValue: Unknown data type: " + otype);
	return "unknown";
}
	function cATTDbg::pListContainer(obj,dspflg=0)
//	----------------------------------------------
//	List a table, class or instance. Sort contents before printing
//	Function names are not listed unless c_listfuncs is true
{
	local	item=[];

	notifyallexceptions(false);

	try {						// Try to use _nexti
	  foreach (i,val in obj)			// List container
	    if((::type(val) != "function" || c_listfuncs) &&
	       (!(dspflg & ATT_DF_FILTER) || pMatchFilter(i))) item.push(i);
	}
	catch(e) {
	  foreach (i,val in obj.getclass())		// List container
	    if((::type(obj[i]) != "function" || c_listfuncs) &&
	       (!(dspflg & ATT_DF_FILTER) || pMatchFilter(i))) item.push(i);
	}

	notifyallexceptions(true);

	if(dspflg & ATT_DF_SORT) item.sort();

//	If TILE specified and obj is an instance, assume AITileList being listed
//	Use table entry name, not value

	if((dspflg & ATT_DF_TILE) && ::type(obj) == "instance") {
	  foreach (i,val in item)
	    Output(" " + val + ": " + GetValue(val,dspflg & ~ATT_DF_HEX) +
		   ": " + GetValue(obj[val],dspflg & ~ATT_DF_TILE));
	}
	else {
	  foreach (i,val in item)
	    Output(" " + val + ": " + GetValue(obj[val],dspflg));
	}
}
	function cATTDbg::pMatchFilter(name)
//	------------------------------------
//	Match name to class/table filter entries
//	Returns true if match
{
	if(!c_filter) return true;

	foreach (i,val in c_filter)
	  if(MatchPattern(name,val)) return true;

	return false;
}
	function cATTDbg::Ex(...)
//	-------------------------
//	Examine variables in locals or this table of caller
//	...	variable name strings. ie: Ex("i","j");
//	Note: Squirrel automatically dereferences weakrefs accessed
//	      via locals[var], so no * in front of weakref names
{
	local	locals = getstackinfos(2).locals;

	for (local c=0; c < vargc; c++) {
	  local	varg = vargv[c];
	  local	varga = split(varg,",");
	  
	  foreach (i,expr in varga) {
	    local ret = EvaluateExpr(locals,expr);

	    if(ret.errcode)
	      Examine(expr,ret.value,true);
	    else
	      OutputW("Error evaluating expression: " + ret.e);
	  }
	}
}
	function cATTDbg::ExecCmdProc(filename)
//	---------------------------------------
//	Execute ATTDebug command file (.att)
{
	local	fd = cATTIO(),filespec = filename + ".att";

	if(!fd.Open(filespec)) return ATT_E_FILEOPEN;

	local	errcode = ATT_E_SUCCESS;

	c_cmdlvl++;

	while (!fd.EOF()) {
	  local cmd = fd.Read();

	  if(cmd.len() && (errcode = ParseCommand(cmd)) != ATT_E_SUCCESS) break;
	}

	c_cmdlvl--;

	return errcode;
}
	function cATTDbg::GetStackLevel()
//	---------------------------------
//	Search stack for DebugHook function name
//	Returns		stack level for caller to use to get scope 0
{
	local	level=2,si;

	while (si = getstackinfos(level)) {
	  if(si.func == "Debug" || si.func == "DebugEH") return level;

	  level++;
	}

	OutputE("Scope 0 stack level not found");
	return 0;
}
	function cATTDbg::ConvertWildcards(pattern)
//	-------------------------------------------
//	Convert a pattern that contains wildcards * and % to compiled regex
{
	local	regex = "";

	for (local i=0; i < pattern.len(); i++) {
	  switch (pattern[i]) {
	  case '*':
	    regex += ".*";
	    break;

	  case '%':
	    regex += ".";
	    break;

	  default:
	    regex += pattern[i].tochar();
	  }
	}

	return regexp(regex);
}
	function cATTDbg::MatchPattern(string,pattern)
//	----------------------------------------------
//	Check if STRING matches PATTERN
//	Pattern may contain wildcard characters * and %
//	Returns true if match
{
	local	sl = string.len(), pl = pattern.len();
	local	wild,rl;
	local	sp,pp;

	wild = 0;				// No wildcard found yet
	sp = 0;					// String pointer
	pp = 0;					// Pattern pointer

	for (;;) {
	  if(pp >= pl) {			// End of pattern
	    if(sp >= sl) return true;		// End of string - match
	    if(wild) return true;

	    return false;			// Not enough pattern chrs
	  }

	  switch (pattern[pp]) {		// Pattern character
	  case '%':
	    if(sp >= sl) return false;
	    sp++;
	    pp++;
	    continue;

	  case '*':
	    wild = 1;				// Wildcard found
	    pp++;
	    continue;
	  }

//	  Ordinary character in pattern

	  if(sp >= sl) return false;		// Not enough str chrs

	  if(!wild) {
	    if(string[sp] != pattern[pp]) return false;
	    sp++;
	    pp++;
	    continue;
	  }

	  break;
	}

//	Process floating pattern (*A)

	do {
	  if(string[sp] == pattern[pp] &&	// Matched floating chr
	     MatchPattern(string.slice(sp),pattern.slice(pp))) return true;

	  sp++;					// Skip string chr
	} while (sp < sl);			// Not enough str chrs

	return false;
}
	function cATTDbg::SplitCommandLine(cmdline)
//	-------------------------------------------
//	Split command into parts at ';'
//	Returns		array with individual commands or ATT_PE_ code
{
	local	st=0, pos=0, inpar=0, cmdlen=cmdline.len();
	local	arr = [];

	while (pos < cmdlen) {			// Find ';'
	  switch (cmdline[pos]) {
	  case ')':
	    if(--inpar < 0) return ATT_PE_UNMATCH;

	    break;

	  case '(':
	    inpar++;
	    break;

	  case '"':
	  case '\'':
	    local i = pos++;

	    while (pos < cmdlen && cmdline[pos] != cmdline[i])
	      pos++;

	    if(pos == cmdlen) return ATT_PE_SYNTAX;

	    break;

	  case ';':
	    if(!inpar) {
	      if(pos > st) arr.push(cmdline.slice(st,pos));

	      st = pos + 1;
	    }

	    break;
	  }

	  pos++;
	}

	if(inpar) return ATT_PE_UNMATCH;

	if(pos > st) arr.push(cmdline.slice(st,pos));

	return arr;
}
