	class cATTIO
//	------------
//	Class to read and write files
{
	c_fd = null;

	constructor() {
	  c_fd = null;
	}
}
	function cATTIO::IsOpen()
//	-------------------------
//	Returns true if file is open
{
	return (c_fd != null);
}
	function cATTIO::Open(filename,mode="r")
//	----------------------------------------
//	Open text file for reading or writing
//	Returns		false if failed
{
	local	stat;

	notifyallexceptions(false);

	try {
	  c_fd = file(filename,mode);
	  stat = true;
	}
	catch(e) {
	  stat = false;
	}

	notifyallexceptions(true);

	return stat;
}
	function cATTIO::Close()
//	------------------------
{
	c_fd = null;
}
	function cATTIO::Read()
//	-----------------------
//	Read characters until LF found, return string without LF
//	Function readn does not seem to return CR characters from text files
{
	local	c,buf = "";

	while (!c_fd.eos()) {
	  if((c = c_fd.readn('c')) == '\n') return buf;

	  buf += c.tochar();
	}

	return buf;
}
	function cATTIO::Write(buf)
//	---------------------------
//	Write to file, appends LF
{
	local	i,len = buf.len();

	for (i=0; i < len; i++)
	  c_fd.writen(buf[i],'c');

	c_fd.writen('\n','c');
}
	function cATTIO::EOF()
//	----------------------
//	Returns true if at End-of-file
{
	return c_fd.eos();
}
