	class cATTParserBase
//	--------------------
//	Class to be extended by parser and app using the parser
{
//	Parser parameter types

	static	_ADDR		= 1;		// Line or function spec
	static	_INT		= 2;		// Integer
	static	_STR		= 3;		// Quoted string
	static	_SYMBOL		= 4;		// Debugger symbol
	static	_WATCH		= 5;		// module\variable
	static	_MODULE		= 6;		// Module name
	static	_SCOPE		= 7;		// Scope name or number
	static	_LINERANGE	= 8;		// [module\]line[:line]
	static	_VAR		= 9;		// Squirrel variable name
	static	_FILE		= 10;		// File name
	static	_EOL		= 11;		// Everything to end of line
	static	_SYMBOLW	= 12;		// Symbol with wildcard * and %

//	Parameter count values or 1 to 9

	static	_ONE_PLUS	= 10;		// Count values
	static	_ZERO_PLUS	= 11;
	static	_ZERO_OR_ONE	= 12;

	static	_HASNO		= 101;		// Qualifier can be NO
	static	_ISNO		= 102;		// Qualifier is negated

//	Indexes for command array

	static	I_FUNCID	= 0;		// Function id
	static	I_QUALIFIERS	= 1;		// Qualifiers table

//	Indexes for qualifier value array

	static	I_NEGFLG	= 0;		// Negated flag

//	Indexes for parameter array

	static	I_PARMTYPE	= 0;		// Parameter value type
	static	I_COUNT		= 1;		// Value count
	static	I_MINVAL	= 2;		// Minimum value
	static	I_MAXVAL	= 3;		// Maximum value

//	Parser errors

	static	ATT_PE_SUCCESS	=  1;

	static	ATT_PE_INVCMD 	= -1;
	static	ATT_PE_SYNTAX 	= -2;
	static	ATT_PE_INVUSE	= -3;
	static	ATT_PE_INVVAL	= -4;
	static	ATT_PE_INVPARM	= -5;
	static	ATT_PE_INVQUAL	= -6;
	static	ATT_PE_TOOMANY	= -7;
	static	ATT_PE_PARMREQ	= -8;
	static	ATT_PE_CONFLICT	= -9;
	static	ATT_PE_PARSER	= -10;
	static	ATT_PE_UNMATCH	= -11;
}
