	function cATT::FindInitialVehicles()
//	------------------------------------
//	Find all possible combination of vehicles for method and cargo
{
	s_g.vehicles <- [[],[],[],[],[]];		// All methods

	foreach (cargo,v in s_cargo2x) {
	  if(v != null) Info("Cargo: "+cargo+" "+AICargo.GetCargoLabel(cargo));

	  for (local i=YATT_CMI_RAIL; i <= YATT_CMI_HELI; i++) {
	    if(v == null)				// No such cargo
	      s_g.vehicles[i].push(null);
	    else {
	      local veh = FindBestVehicle(i,cargo);

	      s_g.vehicles[i].push(veh);

	      if(veh != null) Info("  "+s_rtemethod[i]+": "+veh.name);
	    }
	  }
	}

//	Set distances passengers can be taken

	for (local i=YATT_CMI_RAIL; i <= YATT_CMI_HELI; i++) {
	  s_cdist.min[i] = GetMaxDistForVehicle(i,s_crgpassengers,s_mindays[i]);
	  s_cdist.max[i] = GetMaxDistForVehicle(i,s_crgpassengers,s_maxdays[i]);
	  s_cdist.abs[i] = GetMaxDistForVehicle(i,s_crgpassengers,160);

	  if(i == YATT_CMI_AIR || i == YATT_CMI_HELI) {
	    if(s_cdist.max[i] > s_mapdiag) s_cdist.max[i] = s_mapdiag;
	    if(s_cdist.abs[i] > s_mapdiag) s_cdist.abs[i] = s_mapdiag;
	  }
	}
}
	function cATT::UpdateBestVehicle(method)
//	----------------------------------------
//	Update best vehicles for method and cargo
{
	foreach (cargo,v in s_cargo2x) {
	  local veh = FindBestVehicle(method,cargo);

	  if(veh != null && s_g.vehicles[method][cargo] != null &&
	     veh.engid != s_g.vehicles[method][cargo].engid) {
	    Info("  Cargo:   "+AICargo.GetCargoLabel(cargo));
	    Info("  Replace: "+s_g.vehicles[method][cargo].name);
	    Info("  New:     "+veh.name);
	  }

	  s_g.vehicles[method][cargo] = veh;
	}

	s_cdist.min[method] = GetMaxDistForVehicle(method,
					           s_crgpassengers,s_mindays[method]);
	s_cdist.abs[method] = GetMaxDistForVehicle(method,s_crgpassengers,160);

//	Limit air to max map diagonal distance

	if((method == YATT_CMI_AIR || method == YATT_CMI_HELI) && 
	   s_cdist.abs[method] > s_mapdiag) s_cdist.abs[method] = s_mapdiag;
}
