import("queue.fibonacci_heap","PriorityQueue",2);

	class cATTPQueue extends PriorityQueue
//	--------------------------------------
{
	c_classname = null;

	constructor()
//	-------------
	{
	  PriorityQueue.constructor();

	  c_classname = "cATTPQueue";
	}
}
	class cATTList extends AIList
//	-----------------------------
{
	c_classname = null;

	constructor()
//	-------------
	{
	  AIList.constructor();

	  c_classname = "cATTList";
	}
}
	class cATTTileList extends AITileList
//	-------------------------------------
{
	c_classname = null;

	constructor()
//	-------------
	{
	  AITileList.constructor();

	  c_classname = "cATTTileList";
	}
}
	function cATTTileList::AddSquare(tile,radius)
//	---------------------------------------------
//	Add the rectangle that surrounds a center square
//	tile	Square center
//	radius	Tiles to add on each side
{
	if(AIMap.DistanceFromEdge(tile) > radius) {
	  local offset = AIMap.GetTileIndex(radius,radius);

	  AddRectangle(tile-offset,tile+offset);
	}
	else {
	  local	maxx = AIMap.GetMapSizeX() - 2;
	  local	maxy = AIMap.GetMapSizeY() - 2;
	  local x = AIMap.GetTileX(tile);
	  local y = AIMap.GetTileY(tile);
	  local x1 = x - radius;
	  local	y1 = y - radius;
	  local x2 = x + radius;
	  local y2 = y + radius;

	  if(x1 < 1) x1 = 1;
	  if(y1 < 1) y1 = 1;
	  if(x2 > maxx) x2 = maxx;
	  if(y2 > maxy) y2 = maxy;

	  AddRectangle(AIMap.GetTileIndex(x1,y1),AIMap.GetTileIndex(x2,y2));
	}
}
	function cATTTileList::AddArea(tile1,tile2,radius)
//	--------------------------------------------------
//	Add the rectangle that surrounds a rectangle
//	tile1,tile2	North and South tiles of a valid rectangle
//	radius		Tiles to add on each side
{
	if(AIMap.DistanceFromEdge(tile1) > radius &&
	   AIMap.DistanceFromEdge(tile2) > radius) {
	  local offset = AIMap.GetTileIndex(radius,radius);

	  AddRectangle(tile1-offset,tile2+offset);
	}
	else {
	  local	maxx = AIMap.GetMapSizeX() - 2;
	  local	maxy = AIMap.GetMapSizeY() - 2;
	  local x1 = AIMap.GetTileX(tile1) - radius;
	  local y1 = AIMap.GetTileY(tile1) - radius;
	  local x2 = AIMap.GetTileX(tile2) + radius;
	  local y2 = AIMap.GetTileY(tile2) + radius;

	  if(x1 < 1) x1 = 1;
	  if(y1 < 1) y1 = 1;
	  if(x2 > maxx) x2 = maxx;
	  if(y2 > maxy) y2 = maxy;

	  AddRectangle(AIMap.GetTileIndex(x1,y1),AIMap.GetTileIndex(x2,y2));
	}
}
	function cATTTileList::AddAreaToTile(tile,xlen,ylen,radius)
//	-----------------------------------------------------------
//	Add the rectangle that surrounds a rectangle
//	tile	North tile of rectangle
//	xlen	Length of rectangle in X direction
//	ylen	Length of rectangle in Y direction
//	radius	Tiles to add on each side
{
	local	tile2 = tile + AIMap.GetTileIndex(xlen-1,ylen-1);

	AddArea(tile,tile2,radius);
}
	function cATTTileList::AddRectangleWH(tile,xlen,ylen)
//	-----------------------------------------------------
//	Add rectangle using width and height (does not clip to edges)
//	tile	North corner of rectangle
//	xlen	Length along X axis
//	ylen	Length along Y axis
{
	local	tile2 = tile + AIMap.GetTileIndex(xlen-1,ylen-1);

	AddRectangle(tile,tile2);
}
