	class cATTManager extends cATTBase
//	----------------------------------
{
	c_method = null;			// YATT_CMI_ code
	c_routes = null;			// Routes array
	c_vehs = null;				// Vehid : route

	constructor(method)
//	-------------------
	{
	  c_method = method;
	  c_routes = [];
	  c_vehs = {};
	}
}
	function cATTManager::AddRoute(route)
//	-------------------------------------
//	Create xref route_code : route
{
	route.SetBuiltDate();

	c_routes.push(route);				// We have this route

//	For passengers, add complete route code, both ways, to s_g.routes only
//	We can have multiple passengers routes from/to a town
//	For other cargo we can only have one route taking it

	s_g.routes[route.GetRouteCode()] <- route;	// Global src to dst

	if(route.c_cargo == s_crgpassengers)		// Add reverse route too
	  s_g.routes[route.GetReverseRouteCode()] <- route;

	else {
//	  If source is a town, then destination is a source town too, add it

	  s_g.rtesrc[route.GetSrcCode()] <- route;	// Source xref

	  if(route.c_srctown) s_g.rtesrc[route.GetDstCode()] <- route;

	  AddService(route.GetSrcIDCode(),route);
	  AddService(route.GetDstIDCode(),route);
	}
}
	function cATTManager::RemoveRoute(route)
//	----------------------------------------
//	Remove route from xref tables
{
	if(route.c_cargo != s_crgpassengers) {
	  RemoveService(route.GetSrcIDCode(),route);
	  RemoveService(route.GetDstIDCode(),route);

	  delete s_g.rtesrc[route.GetSrcCode()];	// Source xref

	  if(route.c_srctown) delete s_g.rtesrc[route.GetDstCode()];
	}
	else
	  delete s_g.routes[route.GetReverseRouteCode()];

	delete s_g.routes[route.GetRouteCode()];	// Global src to dst

	foreach (i,rte in c_routes) {
	  if(rte == route) {
	    c_routes.remove(i);
	    break;
	  }
	}
}
	function cATTManager::AddVehicle(route)
//	---------------------------------------
//	Create xref vehid : route
//	Update reserved funds to buy initial vehicles
{
	c_vehs[route.GetLastVehicleAdded()] <- route;

	local	t = RemoveReserve(route);

	if(t && --t.vehicles) {				// One less vehicle
	  t.funds = route.c_engprice * t.vehicles;
	  AddReserve(t);
	}
}
	function cATTManager::AddService(idcode,route)
//	----------------------------------------------
//	Add entry to s_g.rtestp to remember we have a stop here for route
//	idcode		Town/Industry id in form {T|I}id
//	route		The route connected to this place
{
	AddKeyValue(s_g.rtestp,idcode,route);
}
	function cATTManager::RemoveService(idcode,route)
//	-------------------------------------------------
//	Route terminated, remove service entry
//	Returns		true if service was removed
{
	return RemoveKeyValue(s_g.rtestp,idcode,route);
}
	function cATTManager::ReportYearEnd()
//	-------------------------------------
{
	foreach (i,route in c_routes)
	  route.ReportYearEnd(i);
}
	function cATTManager::ListRoutes()
//	----------------------------------
{
	Info("Connections by "+s_rtemethod[c_method]);
	Info("");

	foreach (i,route in c_routes)
	  Info("Route: " + i + "  " + route.GetRouteName());
}
