	class cATTRoadDepot extends cATTDepot
//	-------------------------------------
{
	c_classname = null;
	c_front = null;				// Front tile

	constructor(tile,front)
//	-----------------------
	{
	  ::cATTDepot.constructor(tile);

	  c_classname = "cATTRoadDepot";
	  c_front = front;
	}
}
	function cATTRoadDepot::BuildRoadDepot()
//	----------------------------------------
//	Returns		true if depot and connecting road built
{
	if(c_built) {				// Already built
	  c_refcnt++;				// Incr reference count
	  return true;
	}

	local	stat = true;

	if(!AITile.IsBuildable(c_tile)) stat = DemolishTile(c_tile);

	if(stat) {
	  while (!AIRoad.BuildRoadDepot(c_tile,c_front)) {
	    switch (AIError.GetLastError()) {
	    case AIError.ERR_NOT_ENOUGH_CASH:
	      WaitForFunds();
	      break;

	    default:
	      Error("Error building depot: "+AIError.GetLastErrorString());
	      return false;
	    }
	  }
	}

	c_type = YATT_DEP_ROAD;

	if(!AIRoad.AreRoadTilesConnected(c_tile,c_front)) {
	  local	gHandleTraffic = null;

	  while (!AIRoad.BuildRoad(c_tile,c_front)) {
	    switch (AIError.GetLastError()) {
	    case AIError.ERR_VEHICLE_IN_THE_WAY:
	      if(!gHandleTraffic) gHandleTraffic = HandleTraffic();
	      if(resume gHandleTraffic == YATT_E_TRAFFIC) return false;
	      break;

	    case AIError.ERR_AREA_NOT_CLEAR:
	      if(!DemolishTile(c_front)) return false;
	      break;

	    case AIError.ERR_NOT_ENOUGH_CASH:
	      WaitForFunds();
	      break;

	    default:
	      Error("Error connecting depot: "+AIError.GetLastErrorString());
	      return false;
	    }
	  }
	}

	DepotBuilt(this);

	return true;
}
	function cATTRoadDepot::GetBuildCost()
//	--------------------------------------
{
	local	cost = AIRoad.GetBuildCost(AIRoad.ROADTYPE_ROAD,AIRoad.BT_DEPOT);

	if(!AITile.IsBuildable(c_tile))
	  cost += AITile.GetBuildCost(AITile.BT_CLEAR_HOUSE);

	return cost;
}
	function cATTRoadDepot::DemolishRoadDepot()
//	-------------------------------------------
{
	if(!c_built) return true;			// Not built

	if(c_refcnt > 1) {				// More than 1 rte
	  c_refcnt--;					// Decr reference count
	  return true;
	}

	while (!AIRoad.RemoveRoadDepot(c_tile)) {
	  switch (AIError.GetLastError()) {
	  case AIError.ERR_VEHICLE_IN_THE_WAY:
	    Sleep(10);
	    break;

	  case AIError.ERR_NOT_ENOUGH_CASH:
	    WaitForFunds();
	    break;

	  default:
	    Error("Error removing road depot: "+AIError.GetLastErrorString());
	    return false;
	  }
	}

	DepotDemolished();

	return true;
}
