	class cATTRoute extends cATTBase
//	--------------------------------
{
	static	YATT_SRV_TOWN	= 1;			// Town to town
	static	YATT_SRV_SUPPLY	= 2;			// Ind to town
	static	YATT_SRV_IND	= 3;			// Ind to ind

	static	YATT_NMV_NO		= 0;		// Need more vehicles
	static	YATT_NMV_YES		= 1;
	static	YATT_NMV_UPGRADE	= 2;
	static	YATT_NMV_UPGRADEFLEET	= 3;

	static	YATT_SST_NONE		= 0;		// Service states
	static	YATT_SST_BUYING		= 1;
	static	YATT_SST_SELLING	= 2;
	static	YATT_SST_STEADY		= 3;
	static	YATT_SST_STOPPING	= 4;

	static	YATT_RTB_STOP0		= 0x01;		// Stop 0 built
	static	YATT_RTB_STOP1		= 0x02;		// Stop 1 built
	static	YATT_RTB_DEPOT0		= 0x04;		// Depot 0 built
	static	YATT_RTB_DEPOT1		= 0x08;		// Depot 1 built

	c_type = null;					// YATT_CMI code
	c_service = null;				// YATT_SRV code
	c_srvstate = null;				// YATT_SST code
	c_cargo = null;					// Cargo type
	c_crgname = null;				// Cargo name
	c_grpid = null;					// Group id
	c_grpname = null;				// Group name

	c_totcap = null;				// Total capacity
	c_psurplus = null;				// Previous surplus
	c_waiting = null;				// Cargo waiting
	c_trperc = null;				// Transported percentage
	c_waitidx = null;				// Stop idx of c_waiting

	c_engsel = null;				// Preferred engine
	c_engprice = null;				// Selected engine price
	c_vehids = null;				// Vehicle ids
	c_maxveh = null;				// Max vehs for length
	c_datesold = null;				// Last vehicle sold
	c_datebought = null;				// Last vehicle bought
	c_saving = null;				// Saving for vehicle

	c_stops = null;					// Array of stops
	c_depots = null;				// Array of depots

	c_srcid = null;					// Source ind/town id
	c_dstid = null;					// Dest ind/town id

	c_srctown = null;				// True if townid
	c_dsttown = null;				// True if townid

	c_srcname = null;				// Source name
	c_dstname = null;				// Destination name

	c_srctile = null;				// Source tile
	c_dsttile = null;				// Destination tile
	c_dist = null;					// Distance src-dst
	c_length = null;				// Actual route length

	c_cost = null;					// Cost to build
	c_builtdate = null;				// Route built date
	c_rtbuilt = null;				// YATT_RTB flags

	c_profit = null;				// Last year profit
	c_profit2 = null;				// Profit before last
	c_avgprofit = null;				// Profit/vehicle
	c_avgprofit2 = null;				// Profit before last

	constructor(type)
//	-----------------
//	type	YATT_CMI_ code
	{
	  c_type = type;				// Route type
	  c_srvstate = YATT_SST_NONE;

	  c_stops = [];
	  c_depots = [];
	  c_cost = 0;
	  c_vehids = [];
	  c_totcap = 0;
	  c_psurplus = 0;
	  c_datesold = 0;
	  c_datebought = 0;
	  c_saving = false;
	  c_profit = 0;
	  c_profit2 = 0;
	  c_avgprofit = 0;
	  c_avgprofit2 = 0;
	  c_rtbuilt = 0;
	}
}
	function cATTRoute::SetRouteCargo(cargo)
//	----------------------------------------
{
	c_cargo = cargo;
}
	function cATTRoute::SetBuiltDate()
//	----------------------------------
{
	c_builtdate = AIDate.GetCurrentDate();
}
	function cATTRoute::InitFromTable(t)
//	------------------------------------
//	Initialize fields from passed table
{
	c_srcid = t.srcid;
	c_dstid = t.dstid;

	c_srctown = t.srctown;
	c_dsttown = t.dsttown;

	c_srctile = t.srctile;
	c_dsttile = t.dsttile;
	c_dist = (c_type < YATT_CMI_AIR) ? t.distm : t.dists;

	c_cargo = t.cargo;

	c_service = (c_srctown) ? YATT_SRV_TOWN :
				  (c_dsttown) ? YATT_SRV_SUPPLY : YATT_SRV_IND;

	c_crgname = AICargo.GetCargoLabel(c_cargo);
	c_srcname = (c_srctown) ? AITown.GetName(c_srcid) :
				  AIIndustry.GetName(c_srcid);
	c_dstname = (c_dsttown) ? AITown.GetName(c_dstid) :
				  AIIndustry.GetName(c_dstid);
}
	function cATTRoute::GetRouteName()
//	----------------------------------
{
	return  AICargo.GetCargoLabel(c_cargo) + " - " +
		AIStation.GetName(c_stops[0].c_id) + " to " +
		AIStation.GetName(c_stops[1].c_id);
}
	function cATTRoute::GetRouteCode()
//	----------------------------------
//	Encode route parameters to {T|I}srcid_{T|I}dstid_cargo
{
	return ((c_srctown) ? "T" : "I") + c_srcid + "_" +
	       ((c_dsttown) ? "T" : "I") + c_dstid + "_" + c_cargo;
}
	function cATTRoute::GetReverseRouteCode()
//	-----------------------------------------
//	Encode reverse route parameters to {T|I}dstid_{T|I}srcid_cargo
{
	return ((c_dsttown) ? "T" : "I") + c_dstid + "_" +
	       ((c_srctown) ? "T" : "I") + c_srcid + "_" + c_cargo;
}
	function cATTRoute::GetSrcCode()
//	--------------------------------
//	Encode route source parameters to {T|I}srcid_cargo
{
	return ((c_srctown) ? "T" : "I") + c_srcid + "_" + c_cargo;
}
	function cATTRoute::GetDstCode()
//	--------------------------------
//	Encode route destination parameters to {T|I}dstid_cargo
//	Should only be used for town destinations
{
	return ((c_dsttown) ? "T" : "I") + c_dstid + "_" + c_cargo;
}
	function cATTRoute::GetSrcIDCode()
//	----------------------------------
//	Encode source town/industry id to {T|I}srcid
{
	return ((c_srctown) ? "T" : "I") + c_srcid
}
	function cATTRoute::GetDstIDCode()
//	----------------------------------
//	Encode destination town/industry id to {T|I}srcid
{
	return ((c_dsttown) ? "T" : "I") + c_dstid
}
	function cATTRoute::GetCargoSurplus()
//	-------------------------------------
//	Returns cargo above/below route carrying capacity
{
	c_waitidx = 0;
	c_waiting = GetCargoWaitingAtStop(0);
	c_trperc = GetLastMonthTransportedPercentage(0);

	if(!c_srctown)					// Industry source
	  return c_waiting - GetUnusedCapacity();

	local	waiting1 = GetCargoWaitingAtStop(1);

	if(waiting1 < c_waiting) {			// Use lower waiting
	  c_waiting = waiting1;
	  c_waitidx = 1;				// Other end
	  c_trperc = GetLastMonthTransportedPercentage(1);
	}

	return c_waiting - c_totcap / 2;
}
	function cATTRoute::GetUnusedCapacity()
//	---------------------------------------
//	Sum unused capacity of vehicles
{
	local	sum = 0;

	foreach (i,vehid in c_vehids)
	  sum += AIVehicle.GetCapacity(vehid,c_cargo) -
		 AIVehicle.GetCargoLoad(vehid,c_cargo);

	return sum;
}
	function cATTRoute::GetCargoWaitingAtStop(endidx)
//	-------------------------------------------------
{
	return c_stops[endidx].GetCargoWaiting(c_cargo);
}
	function cATTRoute::GetLastMonthTransportedPercentage(endidx)
//	-------------------------------------------------------------
{
	local	id,town;

	if(!endidx) {
	  id = c_srcid;
	  town = c_srctown;
	}
	else {
	  id = c_dstid;
	  town = c_dsttown;
	}

	if(town) return AITown.GetLastMonthTransportedPercentage(id,c_cargo);

	return AIIndustry.GetLastMonthTransportedPercentage(id,c_cargo);
}
	function cATTRoute::GetLastVehicleAdded()
//	-----------------------------------------
{
	return c_vehids[c_vehids.len()-1];
}
	function cATTRoute::SellVehicle(vehid,renew=false)
//	--------------------------------------------------
{
	Info(GetRouteName() + ": Sold " + AIVehicle.GetName(vehid));

	RemoveVehicle(vehid);
	AIVehicle.SellVehicle(vehid);

	if(!renew) c_datesold = AIDate.GetCurrentDate();
}
	function cATTRoute::RemoveVehicle(vehid)
//	----------------------------------------
{
	c_totcap -= AIVehicle.GetCapacity(vehid,c_cargo);	// Total capacity

	foreach (i,vid in c_vehids) {
	  if(vid == vehid) {
	    c_vehids.remove(i);
	    break;
	  }
	}
}
	function cATTRoute::SendVehicleToDepot(vehid,unload=true)
//	---------------------------------------------------------
//	If vehicle is carrying cargo, modify destination order to unload only
//	and insert order to go to nearest depot next, where it will stop
//	unload		If true, vehicle will be unloaded first
{
	if(!unload || !AIVehicle.GetCargoLoad(vehid,c_cargo))
	  AIVehicle.SendVehicleToDepot(vehid);
	else {
	  local ordidx = AIOrder.ResolveOrderPosition(vehid,AIOrder.ORDER_CURRENT);
	  local nonstop = (c_type != YATT_CMI_AIR) ?
				AIOrder.AIOF_NON_STOP_INTERMEDIATE : 0;

	  while (true) {
	    if(AIOrder.IsGotoStationOrder(vehid,ordidx)) {

	      if(AIOrder.IsGotoDepotOrder(vehid,ordidx+1) &&
		 (AIOrder.GetOrderFlags(vehid,ordidx+1) & 
			AIOrder.AIOF_GOTO_NEAREST_DEPOT)) break;// Already done

	      AIOrder.SetOrderFlags(vehid,ordidx,
				    nonstop |
			  	    AIOrder.AIOF_UNLOAD | AIOrder.AIOF_NO_LOAD);

	      AIOrder.InsertOrder(vehid,ordidx+1,0,
				  nonstop |
				  AIOrder.AIOF_GOTO_NEAREST_DEPOT |
				  AIOrder.AIOF_STOP_IN_DEPOT);
	      break;
	    }

	    if(AIOrder.IsConditionalOrder(vehid,ordidx) &&
	       AIOrder.GetOrderJumpTo(vehid,ordidx) == 0)
	      ordidx = 0;
	    else
	      ordidx++;
	  }
	}
}
	function cATTRoute::SetServiceState(state)
//	------------------------------------------
//	Indicates if route is being built up, winding down and such
//	state		YATT_SST_ code
{
	c_srvstate = state;
}
	function cATTRoute::AppendCondOrder(vehid,jumpto,
					    cond=AIOrder.OC_UNCONDITIONALLY,
					    comp=0,value=0)
//	--------------------------------------------------------------------
{
	AIOrder.AppendConditionalOrder(vehid,jumpto);

	local ordidx = AIOrder.GetOrderCount(vehid) - 1;

	AIOrder.SetOrderCondition(vehid,ordidx,cond);

	if(cond != AIOrder.OC_UNCONDITIONALLY) {
	  AIOrder.SetOrderCompareFunction(vehid,ordidx,comp)
	  AIOrder.SetOrderCompareValue(vehid,ordidx,value);
	}

	return ordidx;
}
	function cATTRoute::IsUsingIndustry(iid)
//	----------------------------------------
//	Check if this route is using an industry
{
	return (!c_srctown && c_srcid == iid) ||
	       (!c_dsttown && c_dstid == iid);
}
	function cATTRoute::CalcProfitLastYear()
//	----------------------------------------
{
	c_profit2 = c_profit;			// Save as previous profit
	c_avgprofit2 = c_avgprofit;

	c_profit = 0;

	foreach (i,vehid in c_vehids)
	  c_profit += AIVehicle.GetProfitLastYear(vehid);

	local	vehicles = GetVehicleCount();

	c_avgprofit = (vehicles) ? c_profit / vehicles : 0;

	return c_profit;
}
	function cATTRoute::ReportYearEnd(rteidx)
//	-----------------------------------------
//	rteidx		Index in manager
{
	CalcProfitLastYear();

	local	vehicles = GetVehicleCount();
	local	title = "Route: " + rteidx + "  " + GetRouteName();
	local	line1 = "Vehicles: " + vehicles + "  " +
			"Profit: " + c_profit + " ("+c_profit2+") " + 
			"Profit/vehicle: " + c_avgprofit + " ("+c_avgprofit2+")";

	Info("");

	if(c_profit > 0) {
	  Info(title);
	  Info(line1);
	}
	else {
	  Warning(title);
	  Warning(line1);
	}
}
	function cATTRoute::CreateGroup(vehtype)
//	----------------------------------------
//	vehtype		AIVehicle.VT_ type
{
	c_grpid = AIGroup.CreateGroup(vehtype);
	c_grpname = GetRouteName();

	AIGroup.SetName(c_grpid,(c_grpname.len() < 30) ? c_grpname :
							 c_grpname.slice(0,28));
}
	function cATTRoute::GetVehicleCount()
//	-------------------------------------
{
	return c_vehids.len();
}
