	class cATTTaskList extends cATTBase
//	-----------------------------------
{
	c_classname = null;

	c_list = null;				// idx : -date
	c_tasks = null;				// Task array
	c_free = null;				// Free enries in c_tasks
	c_freeptr = null;			// Last used in c_free

	constructor()
//	-------------
	{
	  c_classname = "cATTTaskList";

	  c_list = cATTList();
	  c_tasks = [];
	  c_free = [];
	  c_freeptr = 0;
	}
}
	function cATTTaskList::AddTask(t,days)
//	--------------------------------------
//	Add task to task list
//	Adds index field to task table, can be used to remove the task
//	t	Table defining the task
//	days	Execute so many days from now
{
	local	date = AIDate.GetCurrentDate() + days;
	local	idx;

	if(c_freeptr) {				// Reuse an entry in c_tasks
	  idx = c_free[--c_freeptr];
	  c_tasks[idx] = t;
	}
	else {
	  idx = c_tasks.len();			// Next entry
	  c_tasks.push(t);			// Save task table
	}

	t.index <- idx;				// Task index

	c_list.AddItem(idx,-date);

	return idx;
}
	function cATTTaskList::GetNextTask()
//	------------------------------------
//	Get a task if it is time to execute it
//	Returns		task table or null if nothing scheduled
{
	if(c_list.IsEmpty()) return null;

	local	idx = c_list.Begin();
	local	date = c_list.GetValue(idx);

	if(AIDate.GetCurrentDate() < -date) return null;

	local	t = c_tasks[idx];

	RemoveTask(idx,true);

	return t;
}
	function cATTTaskList::GetTask(idx)
//	-----------------------------------
//	Return the task table at idx, does not remove the task
{
	return c_tasks[idx];
}
	function cATTTaskList::RemoveTask(idx,top=false)
//	------------------------------------------------
//	Remove a task from the task list
//	idx	Task index returned by AddTask
//	top	If task is at top of list, set to true
{
	c_tasks[idx] = null;

	if(top)
	  c_list.RemoveTop(1);
	else
	  c_list.RemoveItem(idx);

	if(c_free.len() == c_freeptr)
	  c_free.push(idx);
	else
	  c_free[c_freeptr] = idx;		// c_taks[idx] is reusable

	c_freeptr++;
}
